/// @cond EO_CXX_EO_IMPL

inline void elm::mapbuf::point_color_set(int idx_, int r_, int g_, int b_, int a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_point_color_set(idx_, r_, g_, b_, a_));
}

inline void elm::mapbuf::point_color_get(int idx_, int* r_, int* g_, int* b_, int* a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_point_color_get(idx_, r_, g_, b_, a_));
}

inline bool elm::mapbuf::auto__get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_auto_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::mapbuf::auto__set(bool on_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_auto_set(::efl::eolian::to_c(on_)));
}

inline bool elm::mapbuf::smooth_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_smooth_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::mapbuf::smooth_set(bool smooth_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_smooth_set(::efl::eolian::to_c(smooth_)));
}

inline bool elm::mapbuf::alpha_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_alpha_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::mapbuf::alpha_set(bool alpha_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_alpha_set(::efl::eolian::to_c(alpha_)));
}

inline bool elm::mapbuf::enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::mapbuf::enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline void eo_cxx::elm::mapbuf::point_color_set(int idx_, int r_, int g_, int b_, int a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_point_color_set(idx_, r_, g_, b_, a_));
}

inline void eo_cxx::elm::mapbuf::point_color_get(int idx_, int* r_, int* g_, int* b_, int* a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_point_color_get(idx_, r_, g_, b_, a_));
}

inline bool eo_cxx::elm::mapbuf::auto__get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_auto_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::mapbuf::auto__set(bool on_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_auto_set(::efl::eolian::to_c(on_)));
}

inline bool eo_cxx::elm::mapbuf::smooth_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_smooth_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::mapbuf::smooth_set(bool smooth_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_smooth_set(::efl::eolian::to_c(smooth_)));
}

inline bool eo_cxx::elm::mapbuf::alpha_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_alpha_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::mapbuf::alpha_set(bool alpha_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_alpha_set(::efl::eolian::to_c(alpha_)));
}

inline bool eo_cxx::elm::mapbuf::enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_mapbuf_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::mapbuf::enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_mapbuf_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline ::eo_cxx::elm::mapbuf::operator ::elm::mapbuf() const
{
   return *static_cast<::elm::mapbuf const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::mapbuf::operator ::elm::mapbuf&()
{
   return *static_cast<::elm::mapbuf*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::mapbuf::operator ::elm::mapbuf const&() const
{
   return *static_cast<::elm::mapbuf const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_mapbuf_point_color_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int idx_, int r_, int g_, int b_, int a_)
{
   try
      {
         static_cast<T*>(self->this_)->point_color_set(idx_, r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_mapbuf_point_color_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int idx_, int* r_, int* g_, int* b_, int* a_)
{
   try
      {
         static_cast<T*>(self->this_)->point_color_get(idx_, r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_mapbuf_auto__get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->auto__get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_mapbuf_auto__set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool on_)
{
   try
      {
         static_cast<T*>(self->this_)->auto__set(::efl::eolian::to_cxx<bool>(on_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_mapbuf_smooth_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->smooth_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_mapbuf_smooth_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool smooth_)
{
   try
      {
         static_cast<T*>(self->this_)->smooth_set(::efl::eolian::to_cxx<bool>(smooth_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_mapbuf_alpha_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->alpha_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_mapbuf_alpha_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool alpha_)
{
   try
      {
         static_cast<T*>(self->this_)->alpha_set(::efl::eolian::to_cxx<bool>(alpha_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_mapbuf_enabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->enabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_mapbuf_enabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->enabled_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::mapbuf >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::container >::template type<T>
   {
      virtual void point_color_set(int idx_, int r_, int g_, int b_, int a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_mapbuf_point_color_set(idx_, r_, g_, b_, a_));
      }

      virtual void point_color_get(int idx_, int* r_, int* g_, int* b_, int* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_mapbuf_point_color_get(idx_, r_, g_, b_, a_));
      }

      virtual bool auto__get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_mapbuf_auto_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void auto__set(bool on_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_mapbuf_auto_set(::efl::eolian::to_c(on_)));
      }

      virtual bool smooth_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_mapbuf_smooth_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void smooth_set(bool smooth_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_mapbuf_smooth_set(::efl::eolian::to_c(smooth_)));
      }

      virtual bool alpha_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_mapbuf_alpha_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void alpha_set(bool alpha_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_mapbuf_alpha_set(::efl::eolian::to_c(alpha_)));
      }

      virtual bool enabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_mapbuf_enabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void enabled_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_mapbuf_enabled_set(::efl::eolian::to_c(enabled_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::mapbuf >
{
   static constexpr int value = 
#if defined(MAPBUF_PROTECTED) && defined(MAPBUF_BETA)
      10
#elif defined(MAPBUF_PROTECTED)
      10
#elif defined(MAPBUF_BETA)
      10
#else
      10
#endif
      + operation_description_class_size<::elm::container >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::mapbuf>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_point_color_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_point_color_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_point_color_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_point_color_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_auto__get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_auto_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_auto__set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_auto_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_smooth_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_smooth_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_smooth_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_smooth_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_alpha_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_alpha_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_alpha_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_alpha_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_enabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_enabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_mapbuf_enabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_mapbuf_enabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::container>(), &ops[operation_description_class_size< ::elm::mapbuf >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::mapbuf>)
{
   return (ELM_MAPBUF_CLASS);
}

} } }

/// @endcond

